/* Common dialog box OpenFileName        */
/* Copyright (C) 1993 by Y.Shirakwa.     */
/* lastupdate 93'05/01                   */

#include <windows.h>
#include <commdlg.h>
#include <stdio.h>
#include <string.h>
#include "cgcur.h"

/***  Global Variables  ***/
extern LPSTR szName[L_SIZE];
/* Common dialog box functions (3.1)
GetOpenFileName	Creates an open-filename dialog box */

int CMUFileOpen(HWND hWnd)
{
     OPENFILENAME ofnTemp;
     DWORD Errval;	/* Error value */
     char buf[5];	/* Error buffer */
     char Errstr[50]="GetOpenFileName returned Error #";
     char szTemp[] = "Cursor Files (*.cur)\0*.cur\0All Files (*.*)\0*.*\0";
     int  returncode;


     ofnTemp.lStructSize       = sizeof( OPENFILENAME );
     ofnTemp.hwndOwner         = hWnd;	 /* An invalid hWnd causes non-modality */
     ofnTemp.hInstance         = 0;
     ofnTemp.lpstrFilter       = szTemp; /* See previous note concerning string */
     ofnTemp.lpstrCustomFilter = NULL;
     ofnTemp.nMaxCustFilter    = 0;
     ofnTemp.nFilterIndex      = 1;
     ofnTemp.lpstrFile         = szName; /* Stores the result in this variable */
	 ofnTemp.nMaxFile          = sizeof( szName );
     ofnTemp.lpstrFileTitle    = NULL;
     ofnTemp.nMaxFileTitle     = 0;
     ofnTemp.lpstrInitialDir   = NULL;
	 ofnTemp.lpstrTitle        = "OpenCursorFile";	/* Title for dialog */
     ofnTemp.Flags             = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
     ofnTemp.nFileOffset       = 0;
     ofnTemp.nFileExtension    = 0;
     ofnTemp.lpstrDefExt       = "*";
     ofnTemp.lCustData         = NULL;
     ofnTemp.lpfnHook          = NULL;
     ofnTemp.lpTemplateName    = NULL;

     returncode = 1;
     if(GetOpenFileName( &ofnTemp ) != TRUE)
     {
          Errval=CommDlgExtendedError();
          if(Errval!=0)	/* 0 value means user selected Cancel */
          {
               sprintf(buf,"%ld",Errval);
               strcat(Errstr,buf);
               MessageBox(hWnd, Errstr,"WARNING",MB_OK|MB_ICONSTOP);
          }
          returncode = 0;
     }
     return returncode;
}
